
class Output
	def initialize(f=STDOUT)
	# if no f, output to STDOUT, if f is a filename then open it, if f is a file use it
	
		@f = f if f.class == IO or f.class == File
		@f=File.open(f,"a") if f.class == String
		
	end
end

class OutputFull < Output
	def out(target, status, results) 
		@f.puts "Identifying: "+ target.to_s
		@f.puts "HTTP-Status: "+ status.to_s
		@f.puts results.pretty_inspect unless results.empty?
		@f.puts
	end
end

class OutputBrief < Output
# don't use colours if not to STDOUT
	def out(target, status, results)
		brief_results=[]
		results.each do |plugin_name,plugin_results|
			unless plugin_results.empty?
				# important info in brief mode is version, type and ?
				# what's the highest probability for the match?
				prob = plugin_results.map {|x| x[:probability] }.compact.sort.uniq.last					
				version = plugin_results.map {|x| x[:version] }.compact.sort.uniq.join(",")
				string = plugin_results.map {|x| x[:string] }.compact.sort.uniq.join(",")
				accounts = plugin_results.map {|x| [x[:account],x[:accounts] ] }.flatten.compact.sort.uniq.join(",")
			
				# be more DRY
			
				if (@f == STDOUT and $use_colour=="auto") or ($use_colour=="always")
					 coloured_string = yellow(string)
					 coloured_string = cyan(string) if plugin_name == "server-header"
 				 	 coloured_string = grey(string) if plugin_name == "title"
					 
					 p = (prob!=100 ? grey(probability_to_words(prob))+ " " : "")  +
					   white(plugin_name) + (!version.empty? ? "["+green(version)+"]" : "") +
					   (!string.empty? ? "[" + coloured_string+"]" : "") + (!accounts.empty? ? "["+ accounts+"]" : "" )
					 
					 brief_results << p
				else
					brief_results << (prob!=100 ? probability_to_words(prob)+ " " : "")  +
					   plugin_name + (!version.empty? ? "[" + version +"]" : "") +
					   (!string.empty? ? "[" + string+"]" : "") + (!accounts.empty? ? " ["+ accounts+"]" : "" )
				end
			end
		end
		
		if (@f == STDOUT and $use_colour=="auto") or ($use_colour=="always")
			@f.puts blue(target) + " [#{status}] " + brief_results.join(", ")
		else
			@f.puts target + " [#{status}] " + brief_results.join(", ")
		end		
		
	end
end

