Plugin.define "FluxBB" do
author "Andrew Horton"
version "0.1"
description "Opensource forum written in PHP. Homepage: http://fluxbb.org/. Aggressive plugin can identify 1.2.x, 1.3-r718, 1.3-beta2, 1.4-beta2, 1.4-rc1"

# Propuls&#233; par is not hte in French language pack. All languages still have 'Powered by'

examples %w|http://fluxbb.org/forums/ http://www.amdsquad.com/forums/ http://www.le-mesle.net/forum/index.php http://forums.epixplx.com/ http://forum.torg.su/ http://www.badharvest.net/forum forum.utorrent.com |

#fluxbb.org-forums-.html:	            <p id="copyright">Powered by <strong><a href="http://fluxbb.org/">FluxBB</a></strong></p>
#forums.epixplx.com-.html:			    <p class="conr">Powered by <a href="http://fluxbb.org/">FluxBB</a></p>
#forum.torg.su-.html:			        <p class="conr">Powered by <a href="http://fluxbb.org/">FluxBB</a> 1.2.22</p>
#www.amdsquad.com-forums-.html:			<p class="conr">Powered by <a href="http://fluxbb.org/">FluxBB</a></p>
#www.badharvest.net-forum.html:			<p class="conr">Powered by <a href="http://fluxbb.org/">FluxBB</a></p>
#www.le-mesle.net-forum-index.php.:     <p class="conr">Propuls&#233; par <a href="http://fluxbb.org/">FluxBB</a> 1.2.20<br />


matches [
{:name=>"Powered by",
:probability=>100,
:regexp=>/(Powered by|Propuls&#233; par) (<strong>)?<a href="http:\/\/fluxbb.org\/">FluxBB<\/a>/},

# default styles - Cobalt.css  imports  index.html  Lithium.css  Mercury.css  Oxygen.css  Radium.css  Sulfur.css

{:name=>"Default stylesheets= Cobalt|Lithium|Mercury|Oxygen|Radium|Sulfur",
:probability=>25,
:regexp=>/<link rel="stylesheet" type="text\/css" href="style\/(Cobalt|Lithium|Mercury|Oxygen|Radium|Sulfur).css" \/>
/},

{:name=>"navlogin",
:probability=>75,
:text=>'<li id="navlogin"><a href="login.php">'
},

{:name=>"brdwelcome",
:probability=>75,
:regexp=>/<div id="brdwelcome" class="inbox">\s+<p>[^<]+<\/p>\s+<\/div>/}
]

def aggressive

# 1.3.x identified by lack of /admin_index.php or presence of /admin/ or /include/js/ or lack of /style/Cobalt.css or presence of /style/print.css
# 1.3-r718 or 1.4+  identified by presence of /include/utf8/

# 1.2 or 1.4 identified by /style/Mercury.css
# 02a0558c65d3d2e7c6895f6bd6e1edf9  fluxbb-1.2.x
# c14d6b084de46779f3b6fb396e74be19  fluxbb-1.4-beta2
# f89d52345d2d54a7026703d9a99380a7  fluxbb-1.4-rc1
# 1.3 doesn't exist
# many sites edit the Mercury.css file which must be a nuisance when upgrading

# /style/Sulfur.css
# 8d49e829aaf77164d0be3e05ef67c63d  fluxbb-1.2.x
# 88fb6eac3671593ef57c4b6b76802280  fluxbb-1.4-beta2
# ec6a6ac259f3de9a7c7f1b1b544387ba  fluxbb-1.4-rc1


# this 1 file can identify 1.2.x, 1.3 and 1.4
#1f71f1b79ca455f691b66e91d47523ec  fluxbb-1.2.18/upload/include/template/redirect.tpl
#1f71f1b79ca455f691b66e91d47523ec  fluxbb-1.2.19/upload/include/template/redirect.tpl
#1f71f1b79ca455f691b66e91d47523ec  fluxbb-1.2.20/upload/include/template/redirect.tpl
#1f71f1b79ca455f691b66e91d47523ec  fluxbb-1.2.21/upload/include/template/redirect.tpl
#1f71f1b79ca455f691b66e91d47523ec  fluxbb-1.2.22/upload/include/template/redirect.tpl
#8b8646ca85c42103ab1941ce33b4058c  fluxbb-1.3-beta2/upload/include/template/redirect.tpl
#d7f4ca403f7d4453158b0765196f8173  fluxbb-1.3-r718/upload/include/template/redirect.tpl
#ec3fc0a2fa3c13a8599be3cb4cd2aa71  fluxbb-1.4-beta2/upload/include/template/redirect.tpl
#2b361b3c0a7c6c81fa37da171e2c3514  fluxbb-1.4-rc1/upload/include/template/redirect.tpl

m=[]
# this doesn't work with subdirectorys, like /forum/

to_download = %w| /style/Mercury.css /style/Sulfur.css /style/print.css /include/template/redirect.tpl|
downloads={}
to_download.each do |d|
	# use open-uri
	target = "http://"+@base_uri.host.to_s + d
	
	begin
		doc=open(target, "User-Agent"=>$USER_AGENT)
		puts "Download: #{target}" if $verbose >0
	rescue
		puts "Download failed: #{target}" if $verbose >0
	end
	body="nononononononononononon not found. don't match this 43242342378497"
	body=doc.read unless doc.nil?
	downloads[d] = {:body=>body, :md5sum=>MD5.new(body).to_s}	
end

# this could be improved on - taken from Joomla plugin
version=nil
version = "1.2.x" if downloads["/style/Mercury.css"][:md5sum] == "02a0558c65d3d2e7c6895f6bd6e1edf9"
version = "1.2.x" if downloads["/style/Sulfur.css"][:md5sum] == "8d49e829aaf77164d0be3e05ef67c63d"
version = "1.3" if downloads["/style/print.css"][:body] == "0956e3e8738ee13ee4845b90acd80a9c"
version = "1.4-beta2" if downloads["/style/Mercury.css"][:md5sum] == "c14d6b084de46779f3b6fb396e74be19"
version = "1.4-beta2" if downloads["/style/Sulfur.css"][:md5sum] == "88fb6eac3671593ef57c4b6b76802280"
version = "1.4-rc1" if downloads["/style/Mercury.css"][:md5sum] == "f89d52345d2d54a7026703d9a99380a7"
version = "1.4-rc1" if downloads["/style/Mercury.css"][:md5sum] == "ec6a6ac259f3de9a7c7f1b1b544387ba"

# only really need this file
version = "1.2.x" if downloads["/include/template/redirect.tpl"][:md5sum] == "1f71f1b79ca455f691b66e91d47523ec"
version = "1.3-beta2" if downloads["/include/template/redirect.tpl"][:md5sum] == "8b8646ca85c42103ab1941ce33b4058c"
version = "1.3-r718" if downloads["/include/template/redirect.tpl"][:md5sum] == "d7f4ca403f7d4453158b0765196f8173"
version = "1.4-beta2" if downloads["/include/template/redirect.tpl"][:md5sum] == "ec3fc0a2fa3c13a8599be3cb4cd2aa71"
version = "1.4-rc1" if downloads["/include/template/redirect.tpl"][:md5sum] == "2b361b3c0a7c6c81fa37da171e2c3514"


unless version.nil?
	m << {:name=>"md5sums of css files", :probability=>100, :version=>version}
end	
m
end

end


